// SAR:  
#include     "GAModule.mqh"
#include     "MustHave.mqh"

int          SAR;                                                    //SAR-
double       SARBuffer[];                                            // 
int          MaxSAR=1.0;                                             // SAR

void OnInitSAR()
{
  ArrayResize(SARBuffer,count);
  ArrayInitialize(SARBuffer,0);
}

bool NeedCloseSAR()
{
  CopyBuffer(SAR,0,0,count,SARBuffer);
  CopyOpen(s,tf,0,count,o);
  Print(TimeToString(TimeCurrent()),";","StrategySAR:NeedCloseSAR",
        ";","SAR[0]=",SARBuffer[0],";","SAR[1]=",SARBuffer[1],";","Open[0]=",o[0],";","Open[1]=",o[1]);
  if((SARBuffer[0]>o[0]&&SARBuffer[1]<o[1])||
     (SARBuffer[0]<o[0]&&SARBuffer[1]>o[1]))
  {
    if(PositionsTotal()>0)
    {
      ClosePosition();
      return(true);
    }
  }
  return(false);
}

bool NeedOpenSAR()
{
  CopyBuffer(SAR,0,0,count,SARBuffer);
  CopyOpen(s,tf,0,count,o);
  Print(TimeToString(TimeCurrent()),";","StrategySAR:NeedOpenSAR",
        ";","SAR[0]=",SARBuffer[0],";","SAR[1]=",SARBuffer[1],";","Open[0]=",o[0],";","Open[1]=",o[1]);
  if(SARBuffer[0]<o[0]&&SARBuffer[1]>o[1])
  {
    request.type=ORDER_TYPE_SELL;
    OpenPosition();
    return(false);
  }
  if(SARBuffer[0]>o[0]&&SARBuffer[1]<o[1])
  {
    request.type=ORDER_TYPE_BUY;
    OpenPosition();
    return(false);
  }
  return(true);
}

double FFSAR(double par1,double par2,double par3,double par4,double par5)
{
  int    b;
  bool   FFtrig=false;                                               //  ?
  string dir="";                                                     //  
  double OpenPrice;                                                  //  
  double t=cap;                                                      // 
  double maxt=t;                                                     // 
  double aDD=0.0;                                                    // 
  double rDD=0.000001;                                               // 
  SAR=iSAR(s,tf,par1,par2);
  dig=MathPow(10.0,(double)SymbolInfoInteger(s,SYMBOL_DIGITS));
  leverage=AccountInfoInteger(ACCOUNT_LEVERAGE);
  contractSize=SymbolInfoDouble(s,SYMBOL_TRADE_CONTRACT_SIZE);
  b=MathMin(Bars(s,tf)-1-count-MaxMAPeriod,depth);
  for(from=b;from>=1;from--)                                         //   
  {
    CopyBuffer(SAR,0,from,count,SARBuffer);
    if((SARBuffer[0]>o[0]&&SARBuffer[1]<o[1])||
       (SARBuffer[0]<o[0]&&SARBuffer[1]>o[1]))
    {
      if(FFtrig==true)
      {
        if(dir=="BUY")
        {
          CopyOpen(s,tf,from,count,o);
          if(t>0) t=t+t*optF*leverage*(o[1]-OpenPrice)*dig/contractSize; else t=0;
          if(t>maxt) {maxt=t; aDD=0;} else if((maxt-t)>aDD) aDD=maxt-t;
          if((maxt>0)&&(aDD/maxt>rDD)) rDD=aDD/maxt;
        }
        if(dir=="SELL")
        {
          CopyOpen(s,tf,from,count,o);
          if(t>0) t=t+t*optF*leverage*(OpenPrice-o[1])*dig/contractSize; else t=0;
          if(t>maxt) {maxt=t; aDD=0;} else if((maxt-t)>aDD) aDD=maxt-t;
          if((maxt>0)&&(aDD/maxt>rDD)) rDD=aDD/maxt;
        }
        FFtrig=false;
      }
   }
    if(SARBuffer[0]<o[0]&&SARBuffer[1]>o[1])
    {
      CopyOpen(s,tf,from,count,o);
      OpenPrice=o[1];
      dir="SELL";
      FFtrig=true;
    }
    if(SARBuffer[0]>o[0]&&SARBuffer[1]<o[1])
    {
      CopyOpen(s,tf,from,count,o);
      OpenPrice=o[1];
      dir="BUY";
      FFtrig=true;
    }
  }
  Print(TimeToString(TimeCurrent()),";","StrategySAR:FFSAR",
        ";","Step=",par1,";","Max=",par2,
        ";","rDD=",rDD,";","Cap=",t);
  if(rDD<=trainDD) return(t); else return(0.0);
}

void GTRSAR(double par1,double par2,double par3,double par4,double par5)
{
  SAR=iSAR(s,tf,par1,par2);
  CopyBuffer(SAR,0,from,count,SARBuffer);
  Print(TimeToString(TimeCurrent()),";","StrategySAR:GTRSAR",
        ";","Step=",par1,";","Max=",par2);
}